//
// Jing Chan '02-'03
// MMORPG - particle.h
// Particle engine handling
//


#ifndef __PARTICLE
#define __PARTICLE

#include "vecmath.h"

#define MAX_EFFECTS 1000
#define MAX_PSOURCES 1000
#define MAX_PARTS 1000
#define MAX_PROJ 1000

extern struct Effect* Effects[MAX_EFFECTS];

typedef struct{
	vec3 start;
	vec3 end;
} Effectz;




typedef struct{
        vec3 pos;
        vec3 vel;
        vec1 life;
} Particle;

typedef struct{
        vec1 freq;
        vec1 time;
		
		vec3* pos;
		
		vec3 p_vel;
		vec3 p_accel;
		vec1 p_life;
        Particle parts[MAX_PARTS];
} P_Source;


typedef struct{
	vec3 pos;
	vec3 vel;

} Proj;


void drawRail( vec3 start, vec3 end, vec3 colorLine, vec3 colorTrail );


void pInit();

void psCreate( vec3* pos ); //P_Source* a );
void psDestroy( vec3* pos );
//void psDestroy( P_Source* &a );

void psUpdate( vec1 deltat );
void pUpdate( P_Source* a, vec1 deltat );
void pMake( P_Source* a );

void psDraw( );
void pDraw( P_Source* a );

void projInit();
void projCreate(vec3 pos, vec3 vel);
void projDestroy(Proj* &a);
void projUpdate(vec1 deltat);
void projDraw();


#endif
